#include <TM1636.h>
#include <math.h>

unsigned long prevMill = 0;
const int menubutt = 11;
int bzzpin = 6;
int svetlopin = 1;
int teplopin = 0;
boolean CFswitch = false;
int valF, valC;                
double tempF, tempC; 
int8_t teploC[4], teploF[4];
TM1636 tm1636(7,8);  

double ThermistorF(int RawADC) { // výpočet teploty v Frh
 double Temp;
 Temp = log(10000.0*((1024.0/RawADC-1))); 
 Temp = 1 / (0.001129148 + (0.000234125 + (0.0000000876741 * Temp * Temp ))* Temp ); 
 Temp = Temp - 273.15;          
 Temp = (Temp * 9.0)/ 5.0 + 32.0; //přepočet na Frh
 return Temp;
}

double ThermistorC(int RawADC) { // výpočet teploty v Cls
 double Temp;
 Temp = log(10000.0*((1024.0/RawADC-1))); 
 Temp = 1 / (0.001129148 + (0.000234125 + (0.0000000876741 * Temp * Temp ))* Temp );
 Temp = Temp - 273.15;          
 return Temp;
}

void setup() {
 Serial.begin(9600);
 pinMode( svetlopin, INPUT );
 pinMode(menubutt, INPUT);
 tm1636.init();
}

void loop() {
  //Serial.println(analogRead(svetlopin));
  //Serial.println(analogRead(teplopin));
  Serial.println(digitalRead(menubutt));
  if (digitalRead(menubutt) == HIGH){ //přepínač na Cls/Frh
    switch (CFswitch){
      case false:
          CFswitch = true;
          break;
      case true:
          CFswitch = false;
          break;
    }
  }
  
  unsigned long curMill = millis(); 
  
  if (analogRead(svetlopin)<= 150){ //pojistka pro nepřerušených 30s
   prevMill = curMill;
   tm1636.clearDisplay();
  }
  else {
  int valF, valC;          //zapsání teplot do tempF a C      
  double tempF, tempC;            
  valF=analogRead(0);      
  tempF=(int8_t)round(ThermistorF(valF));  //zaokrouhlené hodnoty F
  valC=analogRead(0);      
  tempC=(int8_t)round(ThermistorC(valC));  //zaokrouhlené hodnoty C

  switch (CFswitch){
      case false: // vypis teploty v Cls
          if (tempC < 100){ //pokud bude teplota nižší než 100 stupňů (to by měla pokud nehoří) na první místo se nevypíše nic
              teploC[0] = 11;
            }
          teploC[1] = (int8_t)tempC / 10;//druhé místo pro výpis desítky
          teploC[2] = (int8_t)tempC % 10;//třetí místo pro výpis jednotky
          teploC[3] = 30;           //čtvrté místo s výpisem C
          tm1636.display(teploC);
          break;
      case true: // vypis teploty v Frh
          if (tempF < 100){ //pokud bude teplota nižší než 100 stupňů na první místo se nevypíše nic
              teploF[0] = 11;
             }
          else { // pokud bude vyšší, vypíše se řád stovek
              teploF[0] = (int8_t)tempF/100;
             }
          teploF[1] = (int8_t)tempF / 10;//druhé místo pro výpis desítky
          teploF[2] = (int8_t)tempF % 10;//třetí místo pro výpis jednotky
          teploF[3] = 16;           //čtvrté místo s výpisem F
          tm1636.display(teploF);
          break;
    }
  
  
  }
 
  if (curMill - prevMill >= 30000) { //pokud uplynulo nepřerušených 30s
      prevMill = curMill;
   do {
        tone(bzzpin, 1000); // spustí se alarm 5Hz
        delay (100);
        noTone(bzzpin);
        delay (100);
    } while ((analogRead(svetlopin)) >= 100); //vypne se jakmile lednici zavřeme


}

}
